﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MSIS.webservices.user;


namespace MSIS
{
    // Creates a New User 
    public partial class NewUser : Form
    {
        public NewUser()
        {
            InitializeComponent();
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                UserService nuser = new UserService();
                nuser.Url = AppSettings.WebServiceUrl + "/" + AppSettings.UserServiceName;

                UserProfile profile = new UserProfile();
                profile.Name = txtName.Text;
                profile.Username = txtUserName.Text;
                profile.Email = txtEmail.Text;

                if (nuser.NewUser(profile, txtPassword.Text.Trim()))
                {
                    
                    MessageBox.Show("Your registration is successful");
                    txtName.Text = "";
                    txtUserName.Text = "";
                    txtEmail.Text = "";
                    txtPassword.Text = "";
                    txtConfirm.Text = "";
                    txtCalendarServiceUsername.Text = "";
                }
                else
                {
                    MessageBox.Show("Your registration is not successful, try again");
                }
                Cursor.Current = Cursors.Default;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btnLogin_Click(object sender, EventArgs e)
        {
            new Login().ShowDialog();
        }

        private void btnHelp_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Enter username from the NTNU Schedule System");
        }

        private void lblEmail_ParentChanged(object sender, EventArgs e)
        {

        }
    }
}