﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MSIS.webservices.collaboration;
using MSIS.webservices.user;

namespace MSIS
{
    public partial class JoinGroupForm : Form
    {
        public JoinGroupForm()
        {
            InitializeComponent();
        }

        private void JoinGroupForm_Load(object sender, EventArgs e)
        {
            try
            {
                //Populating the Combo box
                CollaborationService cb = new CollaborationService();
                string[] gps = cb.GetGroups();
                for (int i = 0; i < gps.Length; i++)
                {
                    comboBoxGroups.Items.Add(gps[i]);
                }

                comboBoxGroups.SelectedIndex = 4;
            }
            
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }

        private void buttonJoin_Click(object sender, EventArgs e)
        {
            try
            {
                Cursor.Current = Cursors.WaitCursor;

                CollaborationService n = new CollaborationService();
                n.Url = AppSettings.WebServiceUrl + "/" + AppSettings.CollaborationWebserviceName;

               
                
               

                string usn = textBoxUserName.Text.Trim();
                string gp = comboBoxGroups.Text;

                

                
                if (n.JoinGroup(usn,gp))
                {
                    MessageBox.Show("You are now a member of this group: " + gp);
                    
                    
                }

                else
                {
                    MessageBox.Show("Unable to join this group:" + gp);
                }
                Cursor.Current = Cursors.Default;
            }


            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                Cursor.Current = Cursors.Default;

            }
        
        }

        private void buttonReset_Click(object sender, EventArgs e)
        {
            textBoxUserName.Text = "";
            comboBoxGroups.Text = "";
        }

        private void menuItemReturnJoin_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}