﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using userService;
using scheduleService;

public partial class _Default : System.Web.UI.Page
{
    UserService webService = new UserService();
    ScheduleService scheduleService = new ScheduleService();
    UserProfile user;

    protected void Page_Load(object sender, EventArgs e)
    {
        //chkboxOutsideStudyprogram.Checked = false;
        lblLoginMessage.Text = "";
        if (!Page.IsPostBack && user == null)
        {
            multiView.ActiveViewIndex = 0;
        }
        
    }
    protected void btnLogin_Click(object sender, EventArgs e)
    {
        if (txtUsername.Text.Length > 0 && txtPassword.Text.Length > 0)
        {
            string username = txtUsername.Text;
            // SHA1 hash
            System.Security.Cryptography.SHA1 sha = new System.Security.Cryptography.SHA1CryptoServiceProvider();
            Encoding enc = Encoding.Default;
            string pass_hash = BitConverter.ToString(sha.ComputeHash(enc.GetBytes(txtPassword.Text))).Replace("-", "");

            try
            {
                user = webService.Login(username, pass_hash);

                if (user.IsAuthenticated)
                {
                    // login successful
                    multiView.ActiveViewIndex = 1;
                }
                else
                {
                    lblLoginMessage.Text = "Incorrect username/password!";
                }
            }
            catch (Exception ex)
            {
                lblLoginMessage.Text = ex.Message;
            }
        }
    }

    protected void PopulateForm(object sender, EventArgs e)
    {
        userId.Value = user.Id.ToString();
        txtFullNameChange.Text = user.Name;
        txtUsernameChange.Text = user.Username;
        txtEmailChange.Text = user.Email;
        txtCalendarServiceUsername.Text = user.CalendarServiceUsername;
        lblStatusMessage.Text = "";
    }

    protected void btnLogOut_Click(object sender, EventArgs e)
    {
        user = null;
        multiView.ActiveViewIndex = 0;
        Response.Redirect("Default.aspx");
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        UserProfile updatedUser = new UserProfile();
        updatedUser.Id = Int32.Parse(userId.Value);
        updatedUser.Name = txtFullNameChange.Text;
        updatedUser.Email = txtEmailChange.Text;
        updatedUser.Username = txtUsernameChange.Text;
        updatedUser.CalendarServiceUsername = txtCalendarServiceUsername.Text;

        string passwordHash = "";

        if (txtUsername.Text.Length < 1)
        {
            lblStatusMessage.Text = "The username can not be empty. Revise your input and try again.";
        }
        
        if (txtPasswordChange.Text.Length > 0)
        {
            if (!txtPasswordChange.Text.Equals(txtPasswordChange.Text))
            {
                lblStatusMessage.Text = "The password did not match, please check your input and try again.";
                return;
            }

            // SHA1 hash
            System.Security.Cryptography.SHA1 sha = new System.Security.Cryptography.SHA1CryptoServiceProvider();
            Encoding enc = Encoding.Default;
            passwordHash = BitConverter.ToString(sha.ComputeHash(enc.GetBytes(txtPasswordChange.Text))).Replace("-", "");
        }

        bool success = webService.UpdateUser(updatedUser, passwordHash);
        updatedUser = null;
        if (success)
        {
            lblStatusMessage.Text = "User profile successfully updated!";
        }
        else
        {
            lblStatusMessage.Text = "An error occured!";
        }
    }

    protected void regUserButton_Click(object sender, EventArgs e)
    {
        multiView.ActiveViewIndex = 2;
    }

    protected void btnNewRegisterUser_Click(object sender, EventArgs e)
    {
        UserProfile profile = new UserProfile();
        profile.Name = txtNewFullName.Text;
        profile.Username = txtNewUsername.Text;
        profile.Email = txtNewEmail.Text;
        profile.CalendarServiceUsername = txtNewCalendarUname.Text;

        if (txtNewUsername.Text.Length == 0 || txtNewUsername.Text.Length > 25)
        {
            lblNewUSerError.Text = "The username is not valid";
            return;
        }
        if (txtNewPassword.Text.Length == 0)
        {
            lblNewUSerError.Text = "Password was not entered";
            return;
        }
        if (!txtNewPassword.Text.Equals(txtNewConfirmPassword.Text))
        {
            lblNewUSerError.Text = "The passwords didn't match! Please edit the passwords and try again!";
            return;
        }
        if (txtNewCalendarUname.Text.Contains("http://") || txtNewCalendarUname.Text.Contains("www."))
        {
            lblNewUSerError.Text = "Please use only the username, not the whole URL adress for the calendar service";
            return;
        }

        string passwordHash = "";
        System.Security.Cryptography.SHA1 sha = new System.Security.Cryptography.SHA1CryptoServiceProvider();
        Encoding enc = Encoding.Default;

        passwordHash = BitConverter.ToString(sha.ComputeHash(enc.GetBytes(txtNewPassword.Text))).Replace("-", "");

        bool success = webService.NewUser(profile, passwordHash);

        if (success)
        {
            lblNewUSerError.Text = string.Format("The user {0} ({1}) was created successfully", profile.Username, profile.Name);
        }
        else
        {
            lblNewUSerError.Text = "The user could not be created. Please try again later.";
        }

    }
    protected void linkReturnToLogin_Click(object sender, EventArgs e)
    {
        multiView.ActiveViewIndex = 0;
    }
}