﻿<%@ Page Debug="true" Language="C#" AutoEventWireup="true" CodeFile="LocationSearch.aspx.cs" Inherits="LocationSearch" %>

<%@ Register assembly="AjaxControlToolkit" namespace="AjaxControlToolkit" tagprefix="ajaxToolkit" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>MSIS Location Search</title>
    <link rel="Stylesheet" type="text/css" href="style.css" media="screen" />
    <script type="text/javascript" language="javascript">
        function DoSearch(source, eventArgs) {
            $get('<%=this.btnSearch.ClientID %>').click();
        }
        function ShowLoader() {
            var e = document.getElementById("loader");
            e.style.visibility = (e.style.visibility == 'visible') ? 'hidden' : 'visible';
        }
    </script>
    <script src="map.js" type="text/javascript" language="javascript"></script>
</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>   
        
    <div id="container" style="width:650px">
        <div id="main">
        <h1>Location Search</h1>
        <h2><strong>This tool can be used to search for locations and buildings on NTNU campus.</strong></h2>
        
        <asp:Panel ID="errorPanel" CssClass="errorbox" runat="server" Visible="false">
        <asp:Label ID="lblError" runat="server" Text=""></asp:Label>
        </asp:Panel>
        
        <table width="100%" cellpadding="0" cellspacing="0" style="padding:5px 0 5px 0">
            <tr>
              <td style="width:20%"><strong>Keywords:</strong></td>
              <td style="width:80%">
              <asp:TextBox ID="txtKeywords" runat="server" CssClass="txtInput2"></asp:TextBox>
              
              <asp:Panel ID="panelLocationsDropdown" runat="server" ScrollBars="Vertical" Height="150px" style="display:none" />
              <ajaxToolkit:AutoCompleteExtender ID="txtKeywords_AutoCompleteExtender" 
                  runat="server" DelimiterCharacters="" Enabled="True"
                  ServicePath="http://kristwa.com/webservices/LocationService.asmx"
                  ServiceMethod="GetLocationListAjax"
                  TargetControlID="txtKeywords"
                  MinimumPrefixLength="2"
                  EnableCaching="true"
                  FirstRowSelected="true"
                  CompletionInterval="50"
                  CompletionSetCount="10"
                  CompletionListElementID="panelLocationsDropdown"
                  CompletionListItemCssClass="autocomplete-item"
                  CompletionListHighlightedItemCssClass="autocomplete-item-highlighted"
                  OnClientItemSelected="DoSearch"
                  OnClientPopulating="ShowLoader"
                  OnClientPopulated="ShowLoader">
              </ajaxToolkit:AutoCompleteExtender>
              
              <asp:Button ID="btnSearch" runat="server" Text="Search" onclick="btnSearch_Click" />
              <img id="loader" style="visibility:hidden" src="images/ajax-loader.gif" alt="" />
              </td>
            </tr>
            <tr><td colspan="2" style="padding-top:5px">
            Enter a keyword or name associated with a location, and suggestions will start to appear immediately.<br /><br />
            <strong>Tip:</strong> Click on the <img src="images/pin.png" alt="Map" /> icon to show the location on a map.
            </td></tr>
        </table>
            
        <asp:Repeater ID="searchResults" runat="server" EnableViewState="false">
            <HeaderTemplate>
            <table class="searchResults" cellspacing="0" cellpadding="0">
                <tr style="border-bottom: solid 2px #000">
                    <th style="width:50%">Location</th>
                    <th style="width:20%">Type</th>
                    <th style="width:20%;text-align:center">Floor</th>
                    <th style="width:10%;text-align:center">Map</th>
                </tr>
                <tr runat="server" visible="<%# IsDataEmpty %>">
                    <td><em>No results found...</em></td>
                </tr>
            </HeaderTemplate>
            
            <ItemTemplate>
            
            <tr class="<%# (Int32.Parse(DataBinder.Eval(Container, "ItemIndex","")) % 2 == 1) ? "alternate-row" : "" %>">
                <td>
                <asp:Image ID="cpeIndicator" runat="server" AlternateText="" CssClass="cpeindicator" />
                <a class="titlelink" runat="server" id="expand" href="#"><%# Eval("Name") %></a>
                </td>
                <td><%# Eval("LocationType").ToString().Replace('_',' ') %></td>
                <td style="text-align:center"><%# Eval("Floor") %></td>
                <td style="text-align:center">
                <a id="showMap" href="#" onclick="setSelectedLocation('<%#Eval("Name")%>','<%#string.Join(",", (Eval("MapData.mapArray") as string[]))%>','<%#string.Join("|", (Eval("MapData.coordinateArray") as string[]))%>');$find('mapPopupExtender').show()"><img src="images/pin.png" alt="Show Map" /></a>
                </td>
            </tr>
            
            
            <tr class="<%# (Int32.Parse(DataBinder.Eval(Container, "ItemIndex","")) % 2 == 1) ? "alternate-row" : "" %>">
                <td colspan="4" style="padding-top:0;padding-bottom:0">
                <asp:Panel ID="locDescription" runat="server" style="overflow:hidden">
                <p style="margin-bottom:6px;margin-top:2px">
                <%# Eval("Description") %><br />
                <em>Keywords: <%# Eval("Keywords") %></em>
                </p>
                </asp:Panel>
                <ajaxToolkit:CollapsiblePanelExtender ID="cpe" 
                runat="server" Enabled="True" TargetControlID="locDescription" CollapsedSize="0"
                ExpandControlID="expand" CollapseControlID="expand" Collapsed="True" ImageControlID="cpeIndicator"
                ExpandedImage="~/images/arrow-down.gif" CollapsedImage="~/images/arrow-right.gif" />
                </td>
            </tr>
            
            </ItemTemplate>
           
            <FooterTemplate>
            </table>
            </FooterTemplate>
        </asp:Repeater>
          
        </div>
        <p class="credits">Design &amp; Development: Sindre Paulsrud Moe</p>
    </div>
    
    <asp:Button ID="dummyBtn" runat="server" style="display:none" />
    <ajaxtoolkit:modalpopupextender ID="mapPopupExtender" runat="server"
    TargetControlID="dummyBtn"
    PopupControlID="mapPopup"
    OkControlID="closePopup"
    BackgroundCssClass="modalBackground"
    PopupDragHandleControlID="popupHeader"
    DropShadow="False">
    </ajaxtoolkit:modalpopupextender>
                  
    <asp:Panel ID="mapPopup" runat="server" CssClass="popup" style="display:none" onselectstart="return false">
        <asp:Panel ID="popupHeader" runat="server" CssClass="popup-header">
        <p>
        <asp:Image ID="closePopup" runat="server" ImageUrl="~/images/window-close.png" CssClass="popup-closebutton" AlternateText="Close Window" />
        <span id="debugLabel"></span>
        <strong>Map: <span id="locname"></span></strong>
        </p>
        </asp:Panel>
        
        <asp:Panel ID="popupControls" runat="server" CssClass="popup-controls">
        <p>
        <a href="#" onclick="zoomIn()">Zoom In</a>&nbsp;&nbsp;<img src="images/zoom-in.gif" style="vertical-align:top" />&nbsp;&nbsp;
        <a href="#" onclick="zoomOut()">Zoom Out</a>&nbsp;&nbsp;<img src="images/zoom-out.gif" style="vertical-align:top" />
        <span style="margin-left: 20px;color:#cc0000"><strong>Tip:</strong> Click-and-drag to move around on the map.</span>
        </p>
        </asp:Panel>
        
        <div id="popupMain" class="popup-main">
            <div id="mapwrapper" style="position:relative">
                <div class="map-container" onmousedown="startDrag(event)">
                    <img id="mapImg" src="" alt="" ondragstart="return false" onmousedown="return false" />
                    <div id="pin" class="pin"></div>
                </div>
            </div>
        </div>
    </asp:Panel>
    </form>
</body>
</html>
