﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using locationService;

public partial class LocationSearch : System.Web.UI.Page
{
    LocationService locationService;
    protected List<Location> locationsDS = new List<Location>();

    protected void Page_Load(object sender, EventArgs e)
    {
        lblError.Text = "";
        errorPanel.Visible = false;
        try
        {
            locationService = new LocationService();
        }
        catch (Exception ex)
        {
            lblError.Text = "Unable to connect to location server: " + ex.Message;
        }

    }

    protected bool IsDataEmpty
    {
        get
        {
            ICollection<Location> list = searchResults.DataSource as ICollection<Location>;
            return list.Count == 0 ? true : false;
        }
    }

    protected void btnSearch_Click(object sender, EventArgs e)
    {
        if (txtKeywords.Text == "")
        {
            ShowError("Please type in a search keyword!");
            return;
        }

        Location[] matchingLocations;
        try
        {
            matchingLocations = locationService.GetLocationByName(txtKeywords.Text);
        }
        catch (Exception ex)
        {
            ShowError("Unable to retrieve locations. Please try again.");
            return;
        }

        if (matchingLocations != null)
        {
            locationsDS = new List<Location>(matchingLocations);
            searchResults.DataSource = locationsDS;
            searchResults.DataBind();
        }
        else
        {
            searchResults.DataSource = locationsDS;
            searchResults.DataBind();
        }
    }

    protected void ShowError(string message)
    {
        lblError.Text = message;
        errorPanel.Visible = true;
    }

}
