var move = false, offsetX, offsetY, imgContainer, img;

function startDrag(e) {
    imgContainer = document.getElementById('mapwrapper');
    img = document.getElementById('mapImg');
    move = true;
    
    if (img.nodeName != 'IMG') {
        return false;
    }
    offsetX = e.clientX - imgContainer.offsetLeft;
    offsetY = e.clientY - imgContainer.offsetTop;
    document.body.onmousemove = moveDrag;
    document.body.onmouseup = endDrag;
    document.onselectstart = nullFunc;
}

function nullFunc(e) {
	return false;
}
function moveDrag(e) {
    e = e || event;
    var ok = false;
    if (move) {
        var imgY = e.clientY - offsetY;
        var imgX = e.clientX - offsetX;

        var windowWidth = document.getElementById('popupMain').offsetWidth;
        var windowHeight = document.getElementById('popupMain').offsetHeight;
        if (imgX < 0 && imgX > windowWidth - img.width) {
            imgContainer.style.left = imgX + 'px';
            ok = true;
        }
        if (imgY < 0 && imgY > windowHeight - img.height) {
            imgContainer.style.top = imgY + 'px';
            ok = true;
        }
        return ok;
    }
}
function endDrag(e) {
    move = false;
    document.body.onmousemove = null;
    document.body.onmouseend = null;
    document.onselectstart = null;
}
function resetMap() {
    if (imgContainer != null) {
        imgContainer.style.left = 0 + 'px';
        imgContainer.style.top = 0 + 'px';
        document.getElementById('pin').style.display = 'none';
    }
}

var locationName;
var zoomLevel = 0;
var mapArray = Array();
var coordArray = Array();

function setMapImage(filename) {
    if (document.getElementById('mapImg').src = '../maps/' + filename) {
        return true;
    }
    return false;
}

function setSelectedLocation(name, maps, coords) {
    locationName = name;
    zoomLevel = 0;
    resetMap();
    document.getElementById('locname').innerHTML = locationName;
    mapArray = maps.split(',');
    coordArray = coords.split('|');
    setMapImage(mapArray[zoomLevel]);
    addPin(coordArray[zoomLevel]);
}

function zoomIn() {
    if (zoomLevel < mapArray.length - 1) {
        zoomLevel++;
        resetMap();
        setMapImage(mapArray[zoomLevel]);
        addPin(coordArray[zoomLevel]);
    } else {
        alert('Maximum zoom level reached');
    }
}

function zoomOut() {
    if (zoomLevel > 0) {
        zoomLevel--;
        resetMap();
        setMapImage(mapArray[zoomLevel]);
        addPin(coordArray[zoomLevel]);
    } else {
        alert('Minimum zoom level reached');
    }
}

function addPin(point) {
    point = { x: point.split(',')[0], y: point.split(',')[1] };
    var pin = document.getElementById('pin');
    pin.style.left = point.x - 13 / 2 + 'px';
    pin.style.top = point.y - 23 + 'px';
    pin.style.display = 'block';
    pin.title = locationName;
}