﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data.SqlClient;
using System.IO;
using System.Net;
using System.Data;


/// <summary>
/// Summary description for CollaborationService
/// </summary>
[WebService(Namespace = "http://msis.myvnc.com/webservices/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class CollaborationService : System.Web.Services.WebService {

    public CollaborationService () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public bool SendGroupMessage(GroupMessage mg,  int Gid, string sendername) 
    {
        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);
        // Terminate if unable to open SQL Connection
        if (!SQLConn.Open())
        {
            return false;
        }

        string sqlQuery = "insert into Group_Message (gid,message,groupmsgdate,sender) values (@gid,@message,@groupmsgdate, @sender)";
        SqlCommand cmd = SQLConn.ExecuteCommand(sqlQuery);
        cmd.Parameters.AddWithValue("message", mg.Message);
        cmd.Parameters.AddWithValue("gid",Gid );
        cmd.Parameters.AddWithValue("groupmsgdate",DateTime.Now);
        cmd.Parameters.AddWithValue("sender", sendername);

        // Execute command
        using (cmd)
        {
            if (cmd.ExecuteNonQuery() > 0)
            {
                //
                SQLConn.Close();
                // Execution completed successfully, resulting in a new row in DB. Returns 'true' to indicate this success.
                return true;
            }
        }

        // Terminate and return false (indicates failure) at this stage (successfull path above)
        SQLConn.Close();
        return false;

    }

    
        [WebMethod]
        public string[] GetGroupMessage(int GroupId) 
        {
            List<String> GroupMessages = new List<string>();

            SQLConn.Open();

            SqlCommand cmd;
            cmd = SQLConn.ExecuteCommand("select message,groupmsgdate, sender from Group_Message where gid = " + GroupId );

            using (SqlDataReader gd = cmd.ExecuteReader())
            {
                while (gd.Read())
                {
                    GroupMessages.Add(gd["message"].ToString().Trim());
                    GroupMessages.Add(gd["groupmsgdate"].ToString());
                    GroupMessages.Add(gd["sender"].ToString());
                }
            }

            SQLConn.Close();
            return GroupMessages.ToArray();

  
       
    

        }  

    

    [WebMethod]
    public Groups[] GetUserGroups(int UserId) 
    { 
  
    Groups[] UserGroups=new Groups[100];
    SQLConn.Open();

         SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand(" select id, name from Groups where id in (select group_id from Group_User where user_id = "+ UserId + " )" );
        int i = 0;
         using (SqlDataReader ug = cmd.ExecuteReader())
        {
            while (ug.Read())
            {
                UserGroups[i] = new Groups();
                UserGroups[i].Name=(ug["name"].ToString().Trim());
                UserGroups[i].Id = (Int16)ug["id"];
                i++;
            }
        }
         UserGroups[0].Total = i;
        SQLConn.Close();
        return UserGroups;

    
    }



    [WebMethod]
    public bool SendPersonalMessage(string msg, string uname, string sender) 
    {

        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);
        // Terminate if unable to open SQL Connection
        if (!SQLConn.Open())
        {
            return false;
        }
        string q = "select id from Users where name like '%" + uname + "%'";
        SqlCommand cm;
        cm = SQLConn.ExecuteCommand(q);
        int Id = 0;
        using (SqlDataReader ug = cm.ExecuteReader())
        {
            while (ug.Read())
            {
                
                Id = (Int16)ug["id"];
              
            }
        }
        
        
        
        string sqlQuery = "insert into User_Message (uid,usermessage,messagedate, sender) values (@uid,@usermessage,@messagedate,@sender)";
        SqlCommand cmd = SQLConn.ExecuteCommand(sqlQuery);
        cmd.Parameters.AddWithValue("usermessage",msg );
        cmd.Parameters.AddWithValue("uid", Id);
        cmd.Parameters.AddWithValue("messagedate", DateTime.Now);
        cmd.Parameters.AddWithValue("sender", sender);
        // Execute command
        using (cmd)
        {
            if (cmd.ExecuteNonQuery() > 0)
            {
                //
                SQLConn.Close();
                // Execution completed successfully, resulting in a new row in DB. Returns 'true' to indicate this success.
                return true;
            }
        }

        // Terminate and return false (indicates failure) at this stage (successfull path above)
        SQLConn.Close();
        return false;
    
    }

    [WebMethod]
    public string[] GetPersonalMessage(int UserId) 
    {

        List<String> UserMessages = new List<string>();

        SQLConn.Open();

        SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand("select usermessage,messagedate, sender from User_Message where uid = " + UserId);

        using (SqlDataReader usmsg = cmd.ExecuteReader())
        {
            while (usmsg.Read())
            {
                UserMessages.Add(usmsg["usermessage"].ToString().Trim());
                UserMessages.Add(usmsg["messagedate"].ToString());
                UserMessages.Add(usmsg["sender"].ToString());
            }
        }

        SQLConn.Close();
        return UserMessages.ToArray();
    
    }

    [WebMethod]
    public bool AddGroup(string groupname, string groupdescription) 
    {
        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);
        // Terminate if unable to open SQL Connection
        if (!SQLConn.Open())
        {
            return false;
        }

        // Create SQLCommand object and prepare statement
        SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand("INSERT INTO Groups (name, description) VALUES (@name, @description)");
        cmd.Parameters.AddWithValue("name", groupname);
        cmd.Parameters.AddWithValue("description", groupdescription);
        


        // Execute command
        using (cmd)
        {
            if (cmd.ExecuteNonQuery() > 0)
            {
                //
                SQLConn.Close();
                // Execution completed successfully, resulting in a new row in DB. Returns 'true' to indicate this success.
                return true;
            }
        }

        // Terminate and return false (indicates failure) at this stage (successfull path above)
        SQLConn.Close();
        return false;
    

       
    
    
    
    }


    [WebMethod]
    public string[] GetGroups()
    {

        List<String> gp = new List<string>();

        SQLConn.Open();

        SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand("select name from Groups");


        using (SqlDataReader rd = cmd.ExecuteReader())
        {
            while (rd.Read())
            {
                gp.Add(rd["name"].ToString().Trim());
            }
        }

        SQLConn.Close();
        return gp.ToArray();
    
    }


    [WebMethod]
    public bool JoinGroup(string usname, string gpname)
    {
        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);
        // Terminate if unable to open SQL Connection
        if (!SQLConn.Open())
        {
            return false;
        }
        string a = "select id from Users where username like '%" + usname + "%'";
        SqlCommand m;
        m = SQLConn.ExecuteCommand(a);
        int Uid = 0;
        using (SqlDataReader ud = m.ExecuteReader())
        {
            while (ud.Read())
            {

                Uid = (Int16)ud["id"];

            }
        }

        string b = "select id from Groups where name like '%" + gpname + "%' ";
        SqlCommand t;
        t = SQLConn.ExecuteCommand(b);
        int Gid = 0;
        using (SqlDataReader k = t.ExecuteReader())
        {
            while (k.Read()) 
            {
                Gid = (Int16)k["id"];
            }
        
        }
        string sqlQuery = "insert into Group_User (group_id, user_id) values (@group_id, @user_id)";
        SqlCommand cd = SQLConn.ExecuteCommand(sqlQuery);
        cd.Parameters.AddWithValue("group_id", Gid);
        cd.Parameters.AddWithValue("user_id", Uid);
        
        // Execute command
        using (cd)
        {
            if (cd.ExecuteNonQuery() > 0)
            {
                //
                SQLConn.Close();
                // Execution completed successfully, resulting in a new row in DB. Returns 'true' to indicate this success.
                return true;
            }
        }

        // Terminate and return false (indicates failure) at this stage (successfull path above)
        SQLConn.Close();
        return false;
    
    }
    
}

