﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data.SqlClient;
using System.Data;
using System.Net;
using System.IO;

/// <summary>
/// Summary description for LearningWebService
/// </summary>
[WebService(Namespace = "http://msis.myvnc.com/webservices/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class LearningWebService : System.Web.Services.WebService {

    public LearningWebService () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 


    }

    [WebMethod]
    public Resource[] GetAvailableResources(string UserId)
    {
        //sql
        
        
        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);
        SqlDataAdapter sqlAdap = new SqlDataAdapter(
            "SELECT * FROM Resource WHERE id IN ( SELECT resourceid from User_Courses WHERE userid = '" + UserId + "')",
            sqlConn);        
        
        DataTable dt = new DataTable();
        sqlAdap.Fill(dt);

        int records = dt.Rows.Count;        

        Resource[] r = new Resource[records];

        for (int i = 0; i < records; i++)
        {
           r[i] = new Resource();
            r[i].Id = int.Parse(dt.Rows[i]["Id"].ToString());
            r[i].Type = dt.Rows[i]["Type"].ToString();
            r[i].Url = dt.Rows[i]["Url"].ToString();
            r[i].Name = dt.Rows[i]["Name"].ToString();
            r[i].Owner = dt.Rows[i]["Owner"].ToString();
            r[i].Course = dt.Rows[i]["Course"].ToString();

        }
        
        return r;
    
    }
    
    [WebMethod]
    public bool AddResource(Resource res, string url)
    {


        
        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);
        // Terminate if unable to open SQL Connection
        if (!SQLConn.Open())
        {
            return false;
        }

        // Create SQLCommand object and prepare statement
        SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand("INSERT INTO Resource (type, url, owner, name, course) VALUES (@type, @url, @owner, @name, @course)");
        cmd.Parameters.AddWithValue("type", res.Type);
        cmd.Parameters.AddWithValue("url", res.Url);
        cmd.Parameters.AddWithValue("owner", res.Owner);
        cmd.Parameters.AddWithValue("name", res.Name);
        cmd.Parameters.AddWithValue("course", res.Course);


        // Execute command
        using (cmd)
        {
            if (cmd.ExecuteNonQuery() > 0)
            {
                //
                SQLConn.Close();
                // Execution completed successfully, resulting in a new row in DB. Returns 'true' to indicate this success.
                return true;
            }
        }

        // Terminate and return false (indicates failure) at this stage (successfull path above)
        SQLConn.Close();
        return false;
    
    
    
    }

    [WebMethod]
    public bool UpdateResource( Resource resource,string url) 
    
    {


        SqlConnection sqlConn = new SqlConnection(SQLConn.connectionString);

        // Terminate if unable to open SQL Connection
        if (!SQLConn.Open())
        {
            return false;
        }

        // Create SQLCommand object and prepare statement
        SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand("UPDATE Resource SET type = @type, url = @url, owner = @owner, name = @name, course = @course WHERE owner like '%" + resource.Owner + "%'");
        cmd.Parameters.AddWithValue("type", resource.Type);
        cmd.Parameters.AddWithValue("url", resource.Url);
        cmd.Parameters.AddWithValue("owner", resource.Owner);
        cmd.Parameters.AddWithValue("name", resource.Name);
        cmd.Parameters.AddWithValue("course", resource.Course);





        // Execute command
        using (cmd)
        {
            if (cmd.ExecuteNonQuery() > 0)
            {
                SQLConn.Close();
                // Execution completed successfully, resulting in a update of row in DB. Returns 'true' to indicate this success.
                return true;
            }
        }

        // Terminate and return false (indicates failure) at this stage (successfull path above)
        SQLConn.Close();
        return false;

    }




    [WebMethod]

    public string[] GetUserCourses() 
    {

        List<String> UserCourses = new List<string>();
        
        SQLConn.Open();

        SqlCommand cmd;
        cmd = SQLConn.ExecuteCommand("select coursecode from User_Courses");
       

        using (SqlDataReader rd = cmd.ExecuteReader())
            {
                while (rd.Read())
                {
                    UserCourses.Add(rd["coursecode"].ToString().Trim());
                }
            }
        
        SQLConn.Close();
        return UserCourses.ToArray();

    
    }


}

